"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Server = void 0;
var react_1 = __importDefault(require("react"));
var fullstack_1 = require("@react-fullstack/fullstack");
var socket_io_1 = __importDefault(require("socket.io"));
/**
 * "@react-fullstack/fullstack" socket server
 */
var Server = /** @class */ (function (_super) {
    __extends(Server, _super);
    function Server() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.componentDidMount = function () {
            _this.server = socket_io_1.default(_this.props.port, _this.props.socketOptions);
            _this.server.sockets.setMaxListeners(0);
            if (_this.props.singleInstance) {
                _this.app = new fullstack_1.App({
                    reactTree: _this.props.children,
                    views: _this.props.views,
                });
                _this.app.startServer(_this.server.sockets);
                _this.server.on("connection", function (socket) {
                    socket.setMaxListeners(0);
                    _this.app.addClient(socket);
                    socket.on("disconnect", function () {
                        _this.app.removeClient(socket);
                    });
                });
            }
            else {
                _this.server.on("connection", function (socket) {
                    var app = new fullstack_1.App({
                        reactTree: _this.props.children,
                        views: _this.props.views,
                    });
                    app.startServer(socket);
                    app.addClient(socket);
                    socket.on("disconnect", function () {
                        app.removeClient(socket);
                        app.close();
                    });
                });
            }
        };
        _this.componentWillUnmount = function () {
            if (_this.server)
                _this.server.close();
            if (_this.app)
                _this.app.close();
        };
        _this.render = function () { return react_1.default.createElement(react_1.default.Fragment, null); };
        return _this;
    }
    return Server;
}(react_1.default.Component));
exports.Server = Server;
